package com.sun.beans.decoder;

import com.sun.beans.finder.FieldFinder;
import java.lang.reflect.Field;

final class FieldElementHandler extends AccessorElementHandler
{
    private Class<?> type;
    
    FieldElementHandler() {
    }
    
    @Override
    public void addAttribute(String s, String s2) {
        if (s.equals("class")) {
            this.type = this.getOwner().findClass(s2);
        }
        else {
            super.addAttribute(s, s2);
        }
    }
    
    @Override
    protected boolean isArgument() {
        return super.isArgument() && this.type != null;
    }
    
    @Override
    protected Object getContextBean() {
        return (this.type != null) ? this.type : super.getContextBean();
    }
    
    @Override
    protected Object getValue(String s) {
        try {
            return getFieldValue(this.getContextBean(), s);
        }
        catch (Exception ex) {
            this.getOwner().handleException(ex);
            return null;
        }
    }
    
    @Override
    protected void setValue(String s, Object o) {
        try {
            setFieldValue(this.getContextBean(), s, o);
        }
        catch (Exception ex) {
            this.getOwner().handleException(ex);
        }
    }
    
    static Object getFieldValue(Object obj, String s) throws IllegalAccessException, NoSuchFieldException {
        return findField(obj, s).get(obj);
    }
    
    private static void setFieldValue(Object obj, String s, Object value) throws IllegalAccessException, NoSuchFieldException {
        findField(obj, s).set(obj, value);
    }
    
    private static Field findField(Object o, String s) throws NoSuchFieldException {
        return (o instanceof Class) ? FieldFinder.findStaticField((Class)o, s) : FieldFinder.findField(o.getClass(), s);
    }
}
